unit aatestform; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls,
  awsassist, ExtCtrls;

type

  { TfrmAwsAssistTest }

  TfrmAwsAssistTest = class(TForm)
    btnExecute: TButton;
    btnClose: TButton;
    chkKeyAsHex: TCheckBox;
    chkDataAsHex: TCheckBox;
    lblKey1Notice: TLabel;
    lblKey2Notice: TLabel;
    lblDataNotice: TLabel;
    lblKey: TLabel;
    lblKey1: TLabel;
    lblKey2: TLabel;
    memData: TMemo;
    memResult: TMemo;
    rgpMode: TRadioGroup;
    txtKey: TEdit;
    lblResult: TLabel;
    lblData: TLabel;
    txtKey1: TEdit;
    txtKey2: TEdit;
    procedure btnExecuteClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { private declarations }
    procedure SHA256;
    procedure SHA256HM;
    procedure SignRequest1;
    procedure SignRequest2;
  public
    { public declarations }
  end; 

var
  frmAwsAssistTest: TfrmAwsAssistTest;

implementation

{ TfrmAwsAssistTest }

procedure TfrmAwsAssistTest.SHA256;
var
  Data1:String;
  Ans1:String;
begin
  Data1:=memData.Text;
  Ans1:=CalcSHA256(PByte(Data1),Length(Data1));

  memResult.Text:=Ans1;
end;

procedure TfrmAwsAssistTest.SHA256HM;
var
  Data1:String;
  Data:String;
  i:Integer;
  Key1:String;
  Ans1:String;
  flg:boolean;
begin
  Data1:='';
  for i:=0 to memData.Lines.Count-1 do
  begin
    Data:=memData.Lines[i];
    flg:=false;
    if Length(Data)>1 then
    begin
      if (Data[Length(Data)-1]='\') and (Data[Length(Data)]='n') then
      begin
        flg:=true;
        Data:=Copy(Data,0,Length(Data)-2);
      end;
    end;
    Data1:=Data1 + Data;
    if flg then
      Data1:=Data1+#10;
  end;

  Key1:=txtKey.Text;
  Ans1:=CalcSHA256HM(PByte(Data1),Length(Data1),PByte(Key1),Length(Key1));

  memResult.Text:=Ans1;
end;

procedure TfrmAwsAssistTest.SignRequest2;
  function Encode32(data:String;var state:TARYPARAM8):Boolean;
  var
    i:Integer;
  begin
    Result:=false;
    if Length(data)<>9*8-1 then
      exit;

    for i:=0 to 7 do
    begin
      state[i]:=StrToInt('$'+Copy(data,i*9+1,8));
    end;
    result:=true;
  end;
var
  Data1:String;
  Data:String;
  i:Integer;
  Ans1:String;
  flg:boolean;
  key1,key2:TARYPARAM8;
begin
  Data1:='';
  for i:=0 to memData.Lines.Count-1 do
  begin
    Data:=memData.Lines[i];
    flg:=false;
    if Length(Data)>1 then
    begin
      if (Data[Length(Data)-1]='\') and (Data[Length(Data)]='n') then
      begin
        flg:=true;
        Data:=Copy(Data,0,Length(Data)-2);
      end;
    end;
    Data1:=Data1 + Data;
    if flg then
      Data1:=Data1+#10;
  end;

  if not Encode32(txtKey1.Text,key1) then
  begin
    showmessage('invalid format:Key1');
    exit;
  end;
  if not Encode32(txtKey2.Text,key2) then
  begin
    showmessage('invalid format:Key2');
    exit;
  end;
  Ans1:=signrequest(Data1,'',@key1,@key2);

  memResult.Text:=Ans1;
end;

procedure TfrmAwsAssistTest.SignRequest1;
  function Encode32(state:TARYPARAM8):String;
  var
    a:Integer;
    i,j:Integer;
  begin
    i:=0; j:=0;
    result:='';
    WHILE j<32 DO BEGIN
      if Length(result)>0 then
        result:=result+' ';
      a:=(state[i] SHR 24) AND $FF;
      result:=result+IntToHex(a AND $FF,2);
      a:=(state[i] SHR 16) AND $FF;
      result:=result+IntToHex(a AND $FF,2);
      a:=(state[i] SHR 8) AND $FF;
      result:=result+IntToHex(a AND $FF,2);
      a:=state[i] AND $FF;
      result:=result+IntToHex(a AND $FF,2);
      INC(i); INC(j,4);
    END;
  end;
var
  Data1:String;
  Data:String;
  i:Integer;
  key:String;
  Ans1:String;
  flg:boolean;
  key1,key2:TARYPARAM8;
begin
  Data1:='';
  for i:=0 to memData.Lines.Count-1 do
  begin
    Data:=memData.Lines[i];
    flg:=false;
    if Length(Data)>1 then
    begin
      if (Data[Length(Data)-1]='\') and (Data[Length(Data)]='n') then
      begin
        flg:=true;
        Data:=Copy(Data,0,Length(Data)-2);
      end;
    end;
    Data1:=Data1 + Data;
    if flg then
      Data1:=Data1+#10;
  end;

  Key:=txtKey.Text;
  Ans1:=signrequest(Data1,Key,@key1,@key2);

  memResult.Text:=Ans1;
  txtKey1.Text:=Encode32(key1);
  txtKey2.Text:=Encode32(key2);
end;

procedure TfrmAwsAssistTest.btnExecuteClick(Sender: TObject);
begin
  case rgpMode.ItemIndex of
    0:
    begin
      SHA256;
    end;
    1:
    begin
      SHA256HM;
    end;
    2:
    begin
      SignRequest1;
    end;
    3:
    begin
      SignRequest2;
    end;
  end;
end;

procedure TfrmAwsAssistTest.btnCloseClick(Sender: TObject);
begin
  Application.Terminate;
end;

initialization
  {$I aatestform.lrs}

end.

